#include "stdafx.h"
#include <vector>
#include <string>
using namespace std;

#include "Board.h"
#include "IPlayer.h"
#include "RailroadSquare.h"
#include "PenaltySquare.h"
#include "PropertySquare.h"
#include "PlusOrMinusSquare.h"
#include "NothingSquare.h"
#include "UtilitySquare.h"
#include "GoToJailSquare.h"

namespace Ribopoly
{
	Board::Board()
	{
		squares_.push_back(new PropertySquare("Mediterranean Avenue", IGameSquare::BalticBrown, 60, 30, 2, 10, 30, 90, 160, 250));
		squares_.push_back(new PlusOrMinusSquare("Community Chest"));
		squares_.push_back(new PropertySquare("Baltic Avenue", IGameSquare::BalticBrown, 60, 30, 4, 20, 60, 180, 320, 450));

		squares_.push_back(new PenaltySquare("Income Tax", 200));

		squares_.push_back(new RailroadSquare("Reading RR", 200, 100));
		
		squares_.push_back(new PropertySquare("Oriental Avenue", IGameSquare::ConnecticutBlue, 100, 50, 6, 30, 90, 270, 400, 550));
		squares_.push_back(new PlusOrMinusSquare("Chance"));
		squares_.push_back(new PropertySquare("Vermont Avenue", IGameSquare::ConnecticutBlue, 100, 50, 6, 30, 90, 270, 400, 550));
		squares_.push_back(new PropertySquare("Connecticut Ave",IGameSquare::ConnecticutBlue, 120, 60, 8, 40, 100, 300, 450, 600));

		squares_.push_back(new NothingSquare("Jail"));


		squares_.push_back(new PropertySquare("St.Charles Place", IGameSquare::VirginiaPurple, 140, 70, 10, 50, 150, 450, 625, 750));
		squares_.push_back(new UtilitySquare("Electric Company", 150.0f, 75.0f));
		squares_.push_back(new PropertySquare("States Avenue", IGameSquare::VirginiaPurple, 140, 70, 10, 50, 150, 450, 625, 750));
		squares_.push_back(new PropertySquare("Virginia Avenue", IGameSquare::VirginiaPurple, 160, 80, 12, 60, 180, 500, 700, 900));

		squares_.push_back(new RailroadSquare("Pennsylvania RR", 200, 100));

		squares_.push_back(new PropertySquare("St.James Place", IGameSquare::NewYorkOrange, 180, 90, 14, 70, 200, 550, 750, 950));
		squares_.push_back(new PlusOrMinusSquare("Community Chest"));
		squares_.push_back(new PropertySquare("Tennessee Avenue", IGameSquare::NewYorkOrange, 180, 90, 14, 70, 200, 550, 750, 950));
		squares_.push_back(new PropertySquare("New York Avenue", IGameSquare::NewYorkOrange, 200, 100, 16, 80, 220, 600, 800, 1000));
		squares_.push_back(new NothingSquare("Free Parking"));

		squares_.push_back(new PropertySquare("Kentucky Avenue", IGameSquare::IllinoisRed, 220, 110, 18, 90, 250, 700, 875, 1050));
		squares_.push_back(new PlusOrMinusSquare("Chance"));
		squares_.push_back(new PropertySquare("Indiana Avenue", IGameSquare::IllinoisRed, 220, 110, 18, 90, 250, 700, 875, 1050));
		squares_.push_back(new PropertySquare("Illinois Avenue", IGameSquare::IllinoisRed, 240, 120, 20, 100, 300, 750, 925, 1100));

		squares_.push_back(new RailroadSquare("B&O RR", 200, 100));

		squares_.push_back(new PropertySquare("Atlantic Avenue", IGameSquare::MarvinGardensYellow, 260, 130, 22, 110, 330, 800, 975, 1150));
		squares_.push_back(new PropertySquare("Ventnor Avenue", IGameSquare::MarvinGardensYellow, 260, 130, 22, 110, 330, 800, 975, 1150));
		squares_.push_back(new UtilitySquare("Water Works", 150, 75));
		squares_.push_back(new PropertySquare("Marvin Gardens", IGameSquare::MarvinGardensYellow, 280, 140, 24, 120, 360, 850, 1025, 1200));
		squares_.push_back(new GoToJailSquare());

		squares_.push_back(new PropertySquare("Pacific Avenue", IGameSquare::PennsylvaniaGreen, 300, 150, 26, 130, 390, 900, 1100, 1275));
		squares_.push_back(new PropertySquare("North Carolina Avenue", IGameSquare::PennsylvaniaGreen, 300, 150, 26, 130, 390, 900, 1100, 1275));
		squares_.push_back(new PlusOrMinusSquare("Community Chest"));
		squares_.push_back(new PropertySquare("Pennsylvania Avenue", IGameSquare::PennsylvaniaGreen, 320, 160, 28, 150, 450, 1000, 1200, 1400));

		squares_.push_back(new RailroadSquare("Short Line", 200, 100));

		squares_.push_back(new PlusOrMinusSquare("Chance"));
		squares_.push_back(new PropertySquare("Park Place", IGameSquare::BoardwalkBlue, 350, 175, 35, 175, 500, 1100, 1300, 1500));
		squares_.push_back(new PenaltySquare("Luxury Tax", 200));
		squares_.push_back(new PropertySquare("Boardwalk", IGameSquare::BoardwalkBlue, 400, 200, 50, 200, 600, 1400, 1700, 2000));
	}

	void Board::addPlayer(IPlayer* player)
	{}

	// Advance a player nSquares and return the square landed on.
	IGameSquare* Board::advance(IPlayer* player, int nSquares)
	{
		return squares_[0];
	}

	Board::~Board(){}

}