#pragma once
#include "stdafx.h"
#include <string>

#include "Board.h"

namespace Ribopoly
{
	class Player;


	class IGameSquare
	{
	public:
		enum Color
		{
           NoColor,
		   BalticBrown,
		   ConnecticutBlue,
		   VirginiaPurple,
		   NewYorkOrange,
		   IllinoisRed,
		   MarvinGardensYellow,
		   PennsylvaniaGreen,
		   BoardwalkBlue
		};

		virtual std::string getName() const = 0;

		virtual Color getColor() const = 0;

		// Returns true if the property is for sale.
		virtual bool forSale() const = 0;

		virtual bool canAddHouse() const = 0;
		virtual bool canAddHotel() const = 0;

		// Returns the price to buy the property
		virtual float getPrice() const = 0;

		// Returns null if there is no owner.
		virtual Player* getOwner() const = 0;

		// Returns false if player cannot legally pay
		virtual bool processLandedOn(Player* playerVisiting) = 0;
	};
}