#pragma once
#include "stdafx.h"
#include <vector>

class IGameSquare;

namespace Ribopoly
{
	class IPlayer
	{
	public:
		enum Token {Wheelbarrow, Battleship, Racecar, Thimble, Shoe, 
			        ScottieDog, TopHat, Cat };

		virtual Token getToken() const = 0;

		// Make the player pay for something.
		// Return false if the player is unable to pay.
		virtual bool charge(float amountToCharge) = 0;

		// Add money to the player's account
		virtual void award(float amoutToAwardToPlayer) = 0;

		virtual float cashAvailable() const = 0;

		// Determine if the player wants to buy a property.
		virtual bool buy(const IGameSquare& gameSquare, const std::vector<IPlayer>& players) const = 0;

		virtual const std::vector<IGameSquare> getRealEstate() const = 0;
	};

}