#pragma once
#include "stdafx.h"
#include <string>
#include "IGameSquare.h"
#include "IPlayer.h"

namespace Ribopoly
{
	class PenaltySquare : public IGameSquare
	{
	public:
		PenaltySquare(const std::string name, float penalty);


		virtual std::string getName() const;

		virtual Color getColor() const;

		// Returns true if the property is for sale.
		virtual bool forSale() const;

		virtual bool canAddHouse() const;
		virtual bool canAddHotel() const;

		// Returns the price to buy the property
		virtual float getPrice() const;

		// Returns null if there is no owner.
		virtual Player* getOwner() const;

		// Returns false if player cannot legally pay
		virtual bool processLandedOn(Player* playerVisiting);
	};
}