#pragma once

#include <string>
#include "IGameSquare.h"

namespace Ribopoly
{
	class PropertySquare : public IGameSquare
	{
	public:
		PropertySquare(
			const std::string& name,
			IGameSquare::Color color,
			float purchasePrice,
			float mortgagePrice,
			float noHouseRent,
			float oneHouseRent,
			float twhoHousesRent,
			float threeHousesRent,
			float fourHousesRent,
			float hotelRent);

		virtual std::string getName() const;

		virtual Color getColor() const;

		// Returns true if the property is for sale.
		virtual bool forSale() const;

		virtual bool canAddHouse() const;
		virtual bool canAddHotel() const;

		// Returns the price to buy the property
		virtual float getPrice() const;

		// Returns null if there is no owner.
		virtual Player* getOwner() const;

		// Returns false if player cannot legally pay
		virtual bool processLandedOn(Player* playerVisiting);


	};
}